/*
 * @file PINFOEx_main.c
 * Module Interface for Module PINFOEx_main
 */

#include "PINFOEx_main.h"

#include <stdio.h>
#include <string.h>

void PINFOEx_main__INITIALIZE__received(PINFOEx_main__context *context)
{
   /* User Code Here */
}

void PINFOEx_main__START__received(PINFOEx_main__context *context)
{
	aLib__SomeType pinfoValue;
	char pinfo[128+sizeof(aLib__SomeType)], key[16], file[128];
	ECOA__int32 chars, fields, i;
	ECOA__uint32 size;
	ECOA__uint8 majVer, minVer;
	ECOA__return_status erc;
	ECOA__log msg;
	aLib__String128 PINFOFileName;
	char* p = pinfo;
	//
	// Get the property value
	PINFOEx_main_container__get_PINFOFile_value( context, &PINFOFileName );
	printf( "PINFOEx_main__START__received: property PINFOFile = %s\n", PINFOFileName );
	//
	// So we could open and the file named by the PINFOFile property, or
	// we can use PINFO...
	//
	// Read the (whole) PINFO
	memset( pinfo, 0, sizeof(pinfo));
	if(( erc = PINFOEx_main_container__read_myPINFOFile( context, (ECOA__byte*)pinfo, 128, &size )) != ECOA__return_status_OK ){
		msg.current_size = sprintf( msg.data, "read_myPINFOFile error code %d", erc );
		PINFOEx_main_container__log_warning( context, msg );
	}
	//
	// Check that the PINFO file is the one we want...
	sscanf( p, "%s%n", key, &chars ); p += chars+1;
	sscanf( p, "%s%n", file, &chars ); p += chars+1;
	if( strcmp( key, "PINFO" ) != 0 || strcmp( file, "PINFOEx.dat" ) != 0 ){
		printf( "PINFOEx_main__START__received: invalid PINFO file.\n"
				"  key  = %s (should be 'PINFO')\n"
				"  file = %s (should be 'PINFOEx.dat')\n", key, file );
		return;
	}
	majVer = (ECOA__uint8)*p; p++;
	minVer = (ECOA__uint8)*p; p++;
	printf( "PINFOEx_main__START__received: reading PINFO from '%s', ver = %d.%d\n", file, majVer, minVer );
	//
	// Now extract the (binary) content
	printf( "Reading the binary content...\n" );
	memcpy( &pinfoValue, p, sizeof(aLib__SomeType) );
	printf( "PINFOEx_main__START__received: pinfoValue.refNo = %d data[1] = %g\n", pinfoValue.refNo, pinfoValue.data.data[1] );
	p += sizeof(aLib__SomeType);
	//
	// Now extract the (ASCII) content
	printf( "Reading the ASCII content...\n" );
	fields = sscanf( p, "%d, %u, %u, %d%n", &(pinfoValue.refNo), &(pinfoValue.timeStamp.seconds), &(pinfoValue.timeStamp.nanoseconds), &(pinfoValue.data.current_size), &chars );
	p += chars;
	for( i = 0; i < pinfoValue.data.current_size; i++ ){
		sscanf( p, ", %g%n", &(pinfoValue.data.data[i]), &chars );
		p += chars;
	}
	printf( "PINFOEx_main__START__received: pinfoValue.refNo = %d data[1] = %g\n", pinfoValue.refNo, pinfoValue.data.data[1] );
}

void PINFOEx_main__STOP__received(PINFOEx_main__context *context)
{
   /* User Code Here */
}

void PINFOEx_main__SHUTDOWN__received(PINFOEx_main__context *context)
{
   /* User Code Here */
}
