/* @file PINFOEx_main_container.h
 * Container Interface header for Module PINFOEx_main
 * Generated automatically from specification; do not modify here
 */

#if !defined(PINFOEX_MAIN_CONTAINER_H)
#define PINFOEX_MAIN_CONTAINER_H


/* Include the types from the XML types files */
#include "ECOA.h"

#include "ECOA.h"

#include "aLib.h"


#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/* Incomplete definition of the technical (platform-dependent) part of the context
 * (it will be defined privately by the container) */
struct PINFOEx_main__platform_hook;

/* Module Context structure declaration */
typedef struct 
{
   /*
    * Other container technical data will accessible through the pointer
    * defined here
    */
   struct PINFOEx_main__platform_hook *platform_hook;

} PINFOEx_main__context;


/* Logging and fault management services API */
void PINFOEx_main_container__log_trace
   (PINFOEx_main__context* context, const ECOA__log log);

void PINFOEx_main_container__log_debug
   (PINFOEx_main__context* context, const ECOA__log log);

void PINFOEx_main_container__log_info
   (PINFOEx_main__context* context, const ECOA__log log);

void PINFOEx_main_container__log_warning
   (PINFOEx_main__context* context, const ECOA__log log);

void PINFOEx_main_container__raise_error
   (PINFOEx_main__context* context, const ECOA__log log);

void PINFOEx_main_container__raise_fatal_error
   (PINFOEx_main__context* context, const ECOA__log log);

/* Time services API */
void PINFOEx_main_container__get_relative_local_time
   (PINFOEx_main__context* context, ECOA__hr_time* relative_local_time);

ECOA__return_status PINFOEx_main_container__get_UTC_time
   (PINFOEx_main__context* context, ECOA__global_time* utc_time);

ECOA__return_status PINFOEx_main_container__get_absolute_system_time
   (PINFOEx_main__context* context, ECOA__global_time* absolute_system_time);

/* Time resolution services API */
void PINFOEx_main_container__get_relative_local_time_resolution
   (PINFOEx_main__context* context, ECOA__duration* relative_local_time_resolution);

void PINFOEx_main_container__get_UTC_time_resolution
   (PINFOEx_main__context* context, ECOA__duration* utc_time_resolution);

void PINFOEx_main_container__get_absolute_system_time_resolution
   (PINFOEx_main__context* context, ECOA__duration* absolute_system_time_resolution);

void PINFOEx_main_container__get_PINFOFile_value
   (PINFOEx_main__context* context,
    aLib__String128* value);

ECOA__return_status PINFOEx_main_container__read_myPINFOFile
   (PINFOEx_main__context* context,
    ECOA__byte *memory_address,
    ECOA__uint32 in_size,
    ECOA__uint32 *out_size);

ECOA__return_status PINFOEx_main_container__seek_myPINFOFile
   (PINFOEx_main__context* context,
    ECOA__int32 offset,
    ECOA__seek_whence_type whence,
    ECOA__uint32 *new_position);


#if defined(__cplusplus)
}
#endif /* __cplusplus */

#endif  /* PINFOEX_MAIN_CONTAINER_H */

